#include "board.h"
using namespace Imagine;

void play() {
    // Q5
    Board b;
    init(b);
    draw(b);
    int nqueens=0;
    // Q12
    while(nfree(b)) {
        int x, y;
        getMouse(x,y);
        if(getCase(x,y) && isfree(b,x,y)) {
            forbid(b,x,y);
            drawCase(b,x,y);
            centerCase(x,y);
            fillCircle(x,y, z/4, BLACK);
            ++nqueens;
        }
    }
    // Q13
    drawString(n*z/2,n*z/2, "Score: "+std::to_string(nqueens), WHITE, 16);
}

// Q16
void check(int t[n]) {
    Board b;
    init(b);
    int i=0;
    for(; i<n; i++) {
        if(! isfree(b,t[i],i))
            break;
        forbid(b,t[i],i);
    }
    if(i==n) {
        draw(b);
        for(int j=0; j<n; j++) {
            int x0=t[j], y0=j;
            centerCase(x0,y0);
            fillCircle(x0,y0, z/4, BLACK);
        }
        // Q17
        drawString(n*z/2,n*z/2, "I'm the boss!", WHITE, 16);
        click();
    }
}

// Q14
struct tab {
    int t[n];
};

// Q15
void permute(tab t, tab u, int k) {
    if(k==n)
        check(t.t);
    for(int i=0; i<n-k; i++) {
        t.t[k]=u.t[i];
        tab up = u;
        for(int j=i; j+1<n-k; j++)
            up.t[j]=up.t[j+1];
        permute(t,up,k+1);
    }
}

// Q15-17
void Imtheboss() {
    tab t,u;
    for(int i=0; i<n; i++)
        u.t[i]=i;
    permute(t,u,0);
}

int main() {
    openWindow(2*border+n*z, 2*border+n*z,"Queens"); // Q5
    play(); // Q12
    click();
    clearWindow();
    Imtheboss();
    return 0;
}
